


#include "snafu.h"
#include "snafu_ui.h"


typedef snafu_popup_objects	Snafu_ui;


/* 
 * yes, a popup has a value!  it is the stuff in the popup
 * when the last validation takes place (or default values on 
 * creation).  this is useful for "Reset" button, or for delaying 
 * creation to boost invokation performance.
 *
 * Note, there is a one-to-one correspondence between this struct
 * and the fields on the Property sheet.
 */
typedef struct {
    char 	name[81];	/* for simplicty, use static buf */
    int		severity;
    Snafu_type	type;
} Snafu_values;



typedef struct {
    Xv_opaque		public_self;
    Snafu_ui		*ui;		/* devguide stuff */
    Snafu_values	*value;		/* popup's value */
    void		(*apply_proc)();
    Frame		owner;
    char		label[81];	/* for simplicty, use static buf */
} Snafu_private;


#define SNAFU_PUBLIC(item)	XV_PUBLIC(item)
#define SNAFU_PRIVATE(item)	XV_PRIVATE(Snafu_private, Snafu_public, item)

#define SNAFU_FROM_OBJ(item)	(Snafu_private *)xv_get((item),XV_KEY_DATA,SNAFU_KEY);

