/*
 * snafu_ui.c - User interface object initialization functions.
 * This file was generated by `gxv' from `snafu.G'.
 * DO NOT EDIT BY HAND.
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <xview/svrimage.h>
#include <xview/termsw.h>
#include <xview/text.h>
#include <xview/tty.h>
#include <xview/xv_xrect.h>
#include "snafu_ui.h"

/*
 * Initialize an instance of object `popup'.
 */
snafu_popup_objects *
snafu_popup_objects_initialize(snafu_popup_objects *ip, Xv_opaque owner)
{
	if (!ip && !(ip = (snafu_popup_objects *) calloc(1, sizeof (snafu_popup_objects))))
		return (snafu_popup_objects *) NULL;
	if (!ip->popup)
		ip->popup = snafu_popup_popup_create(ip, owner);
	if (!ip->controls)
		ip->controls = snafu_popup_controls_create(ip, ip->popup);
	if (!ip->name_text)
		ip->name_text = snafu_popup_name_text_create(ip, ip->controls);
	if (!ip->severity_slider)
		ip->severity_slider = snafu_popup_severity_slider_create(ip, ip->controls);
	if (!ip->type_choice)
		ip->type_choice = snafu_popup_type_choice_create(ip, ip->controls);
	if (!ip->apply_button)
		ip->apply_button = snafu_popup_apply_button_create(ip, ip->controls);
	if (!ip->reset_button)
		ip->reset_button = snafu_popup_reset_button_create(ip, ip->controls);
	return ip;
}

/*
 * Create object `popup' in the specified instance.
 */
Xv_opaque
snafu_popup_popup_create(snafu_popup_objects *ip, Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 398,
		XV_HEIGHT, 266,
		XV_LABEL, "Snafu:  Properties",
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, FALSE,
		FRAME_CMD_PUSHPIN_IN, FALSE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `controls' in the specified instance.
 */
Xv_opaque
snafu_popup_controls_create(snafu_popup_objects *ip, Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `name_text' in the specified instance.
 */
Xv_opaque
snafu_popup_name_text_create(snafu_popup_objects *ip, Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 57,
		XV_Y, 32,
		PANEL_VALUE_DISPLAY_LENGTH, 16,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Name:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_VALUE, "Generic Snafu",
		PANEL_READ_ONLY, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `severity_slider' in the specified instance.
 */
Xv_opaque
snafu_popup_severity_slider_create(snafu_popup_objects *ip, Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_SLIDER,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 88,
		PANEL_SLIDER_WIDTH, 134,
		PANEL_TICKS, 3,
		PANEL_LABEL_STRING, "Severity:",
		PANEL_DIRECTION, PANEL_HORIZONTAL,
		PANEL_SLIDER_END_BOXES, TRUE,
		PANEL_SHOW_RANGE, TRUE,
		PANEL_SHOW_VALUE, TRUE,
		PANEL_MIN_VALUE, 0,
		PANEL_MAX_VALUE, 100,
		PANEL_MIN_TICK_STRING, "Low",
		PANEL_MAX_TICK_STRING, "High",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `type_choice' in the specified instance.
 */
Xv_opaque
snafu_popup_type_choice_create(snafu_popup_objects *ip, Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 62,
		XV_Y, 152,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOOSE_NONE, FALSE,
		PANEL_LABEL_STRING, "Type:",
		PANEL_CHOICE_STRINGS,
			"Nuclear",
			"Chemical",
			"Biological",
			NULL,
		NULL);
	return obj;
}

/*
 * Create object `apply_button' in the specified instance.
 */
Xv_opaque
snafu_popup_apply_button_create(snafu_popup_objects *ip, Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 104,
		XV_Y, 216,
		PANEL_LABEL_STRING, "Apply",
		NULL);
	return obj;
}

/*
 * Create object `reset_button' in the specified instance.
 */
Xv_opaque
snafu_popup_reset_button_create(snafu_popup_objects *ip, Xv_opaque owner)
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 216,
		XV_Y, 216,
		PANEL_LABEL_STRING, "Reset",
		NULL);
	return obj;
}

