/* abb.c -- Abbreviated choices and menus
 * Author:  Kenneth Bibb
 * April 1992 -- Arastar Consulting
 *-----------------------------------
 * Basic frame with abbreviated menu buttons and abbreviated choice buttons
 */

#include <xview/xview.h>
#include <xview/panel.h>

/* call back for abbreviated choice
 */
void selected_choice(item, value, event)
Panel_item item;
int value;
Event *event;
{
	printf("you selected %s\n",
		(char *)xv_get(item, PANEL_CHOICE_STRING, value));
}

/* call back for abbreviated menu
 */
void menu_proc(menu, menu_item)
Menu menu;
Menu_item menu_item;
{
	printf("you want %s\n", (char *)xv_get(menu_item, MENU_STRING));
}

int main(argc, argv)
int argc;
char **argv;
{
	Frame		frame;
	Canvas		canvas;
	Panel		panel;
	Panel_item	pcs;
	Menu		menu;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

	frame = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,	argv[0],
		XV_X,		300,
		XV_Y,		175,
		NULL);

	panel = (Panel)xv_create(frame, PANEL, NULL);

	/* create the abbreviated choice
	 */
	pcs = (Panel_item)xv_create(panel, PANEL_CHOICE_STACK,
		/* PANEL_LAYOUT,	PANEL_VERTICAL, */
		PANEL_LABEL_STRING,	"Systems",
		PANEL_CHOICE_STRINGS,	"Sun", "NeXT", "HP", "PC", NULL,
		PANEL_NOTIFY_PROC,	selected_choice,
		PANEL_VALUE,		0,
		NULL);

	/* a menu to attach to the abbreviated menu
	 */
	menu = (Menu)xv_create(XV_NULL, MENU,
		MENU_ITEM,
			MENU_STRING, "Bah",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Humbug",
			NULL,
		MENU_NOTIFY_PROC, menu_proc,
		NULL);

	/* create the abbreviated menu
	 *----------------------------
	 * why does this need to be +4 to line up correctly?
	 */
	(void)xv_create(panel, PANEL_ABBREV_MENU_BUTTON,
		XV_Y,			xv_get(pcs, XV_Y) + 4,
		PANEL_ITEM_MENU,	menu,
		PANEL_LABEL_STRING,	"Sentiments",
		NULL);

	/* fit the panel around the two abbreviated items
	 */
	window_fit_height(panel);

	/* create a canvas
	 */
	canvas = (Canvas)xv_create(frame, CANVAS, 
		XV_X,		0,
		XV_HEIGHT,	WIN_EXTEND_TO_EDGE,
		XV_WIDTH,	WIN_EXTEND_TO_EDGE,
		CANVAS_X_PAINT_WINDOW,	TRUE,
		NULL);
	window_fit(frame);

	xv_main_loop(frame);
	return(0);
}
