/* choice.c -- Open Look basic choice types
 * Author:  Kenneth Bibb
 * March 1992 -- Arastar Consulting
 *-----------
 * need "show choice" button to print out the string which is chosen.
 * need to add choice_stack
 */

#include <stdlib.h>
#include <sys/param.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/canvas.h>
#include <xview/openmenu.h>
#include <xview/xv_xrect.h>

Attr_attribute  FRAME_BASE_KEY;
Attr_attribute	FRAME_CHOICE_KEY;
Attr_attribute	LANG_CHOICE_KEY;
Attr_attribute	REGION_CHOICE_KEY;
Attr_attribute  CHOICE_BUTTON_KEY;

void menu_stub(m,mi)
Menu m;
Menu_item mi;
{
	char s[48];
	Frame frame = (Frame)xv_get(m, XV_KEY_DATA, FRAME_BASE_KEY, NULL);

	sprintf(s,"Menu: [%s]\n",xv_get(mi,MENU_STRING));
	(void)xv_set(frame, FRAME_LEFT_FOOTER, s, NULL);
}

void show_choice(item, event)
Panel_item item;
Event *event;
{
	char s[48];
	Frame frame = (Frame)xv_get(item, XV_KEY_DATA, FRAME_BASE_KEY);
	Panel_item pi = (Panel_item)xv_get(item,XV_KEY_DATA,
		LANG_CHOICE_KEY);

	sprintf(s,"exclusive: %d-[%s]\n",xv_get(pi,PANEL_VALUE),
		xv_get(pi,PANEL_CHOICE_STRING,xv_get(pi,PANEL_VALUE)));
	(void)xv_set(frame, FRAME_LEFT_FOOTER, s, NULL);
}

void inactive(item, event)
Panel_item item;
Event *event;
{
	Panel_item pi = (Panel_item)xv_get(item,XV_KEY_DATA,LANG_CHOICE_KEY);
	Panel_item pj = (Panel_item)xv_get(item,XV_KEY_DATA,REGION_CHOICE_KEY);
	Panel_item pk = (Panel_item)xv_get(item,XV_KEY_DATA,CHOICE_BUTTON_KEY);

	if(xv_get(pi,PANEL_INACTIVE) == TRUE)
	{
		xv_set(pi,PANEL_INACTIVE,FALSE,NULL);
		xv_set(pj,PANEL_INACTIVE,FALSE,NULL);
		xv_set(pk,PANEL_INACTIVE,FALSE,NULL);
	}
	else
	{
		xv_set(pi,PANEL_INACTIVE,TRUE,NULL);
		xv_set(pj,PANEL_INACTIVE,TRUE,NULL);
		xv_set(pk,PANEL_INACTIVE,TRUE,NULL);
	}
}

void language(item, value, event)
Panel_item item;
int	   value;
Event	  *event;
{
	char s[64];
	Frame frame = (Frame)xv_get(item, XV_KEY_DATA, FRAME_BASE_KEY);

	sprintf(s,"Value: [%d]\t",xv_get(item,PANEL_VALUE));
	(void)xv_set(frame,FRAME_LEFT_FOOTER,s,NULL);
}

void region(item, value, event)
Panel_item item;
unsigned int	   value;
Event	  *event;
{
	char s[64];
	Frame frame = (Frame)xv_get(item, XV_KEY_DATA, FRAME_BASE_KEY);

	sprintf(s,"hex: [%x]:[%8.8s]\t[%8.8s]\t[%8.8s]\t[%8.8s]\n",
		xv_get(item,PANEL_VALUE),
		(xv_get(item,PANEL_VALUE) & (1 << 0))
			? (char *)xv_get(item,PANEL_CHOICE_STRING,0)
			: " ",
		(xv_get(item,PANEL_VALUE) & (1 << 1))
			? (char *)xv_get(item,PANEL_CHOICE_STRING,1)
			: " ",
		(xv_get(item,PANEL_VALUE) & (1 << 2))
			? (char *)xv_get(item,PANEL_CHOICE_STRING,2)
			: " ",
		(xv_get(item,PANEL_VALUE) & (1 << 3))
			? (char *)xv_get(item,PANEL_CHOICE_STRING,3)
			: " "
		);
	(void)xv_set(frame,FRAME_LEFT_FOOTER,s,NULL);
}

void choice_window(m, mi)
Menu m;
Menu_item mi;
{
	Frame Fchoice=(Frame)xv_get(m,XV_KEY_DATA,FRAME_CHOICE_KEY);

	xv_set(Fchoice,XV_SHOW, TRUE, NULL);
}

void show_it(window, event)
Xv_Window window;
Event *event;
{
	if(event_action(event) == ACTION_MENU && event_is_down(event))
	{
		Menu m = (Menu)xv_get(window, WIN_CLIENT_DATA);
		menu_show(m, window, event, NULL);
	}
}

void repaint(canvas, win, dpy, xwin, xrect)
Canvas canvas;
Xv_Window win;
Display *dpy;
Window xwin;
Xv_xrectlist *xrect;
{
	GC gc;
	int width, height;

	gc = DefaultGC(dpy, DefaultScreen(dpy));
	width = (int)xv_get(win,XV_WIDTH);
	height = (int)xv_get(win, XV_HEIGHT);
}

main(argc, argv)
int argc;
char **argv;
{
	Frame		frame;
	Frame		Fchoice;
	Canvas		canvas;
	Panel		panel;
	Panel		Pchoice;
	Menu		m, m_undo;
	Panel_item	ph, pi, pj, pk;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
	FRAME_BASE_KEY=xv_unique_key();
	FRAME_CHOICE_KEY=xv_unique_key();
	LANG_CHOICE_KEY=xv_unique_key();
	REGION_CHOICE_KEY=xv_unique_key();
	CHOICE_BUTTON_KEY=xv_unique_key();

	frame = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,	argv[0],
		FRAME_SHOW_FOOTER, TRUE,
		XV_X,		300,
		XV_Y,		175,
		NULL);
	Fchoice = (Frame)xv_create(frame, FRAME_CMD,
		FRAME_LABEL,	"Choice Examples",
		XV_X,		325,
		XV_Y,		200,
		NULL);
	Pchoice = (Panel)xv_get(Fchoice,FRAME_CMD_PANEL);
	panel = (Panel)xv_create(frame, PANEL,
		NULL);

	m = (Menu)xv_create(NULL, MENU,
		MENU_ACTION_ITEM,	"New...", menu_stub,
		MENU_ACTION_ITEM,	"Save...", menu_stub,
		MENUITEM_SPACE, NULL,
		MENU_ACTION_ITEM,	"Print...", menu_stub,
		MENU_ACTION_ITEM,	"Quit",exit,
		XV_KEY_DATA,	FRAME_BASE_KEY, frame,
		NULL);
	(void)xv_create(panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"File",
		PANEL_ITEM_MENU,	m,	
		NULL);
	(void)xv_create(panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Choice Window...",
		PANEL_NOTIFY_PROC,	choice_window,
		XV_KEY_DATA,		FRAME_CHOICE_KEY, Fchoice,
		NULL);

	ph = xv_create(Pchoice, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Show Choice",
		PANEL_NOTIFY_PROC,	show_choice,
		XV_KEY_DATA,		FRAME_BASE_KEY, frame,
		NULL);
	xv_set(Pchoice,PANEL_DEFAULT_ITEM,ph, NULL);
	pk = (Panel_item)xv_create(Pchoice,PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Inactive",
		PANEL_NOTIFY_PROC,	inactive,
		NULL);
	pi = (Panel_item)xv_create(Pchoice, PANEL_CHOICE,
		PANEL_NEXT_ROW,		-1,
		PANEL_LABEL_STRING,	"Language",
		PANEL_CHOICE_STRINGS,	"Celtic","Gaelic","Irish","Welsh",NULL,
		PANEL_NOTIFY_PROC,	language,
		XV_KEY_DATA, FRAME_BASE_KEY, frame,
		NULL);
	(void)xv_set(ph, XV_KEY_DATA, LANG_CHOICE_KEY, pi, NULL);
	pj = xv_create(Pchoice, PANEL_TOGGLE,
		PANEL_NEXT_ROW,		-1,
		PANEL_LABEL_STRING,	"Region",
		PANEL_CHOICE_STRINGS,	"Bretagne",
					"Scotland",
					"Ireland ",
					"Wales   ",
					NULL,
		PANEL_NOTIFY_PROC,	region,
		XV_KEY_DATA, FRAME_BASE_KEY, frame,
		NULL);
	(void)xv_set(pk, XV_KEY_DATA, LANG_CHOICE_KEY, pi,
			 XV_KEY_DATA, REGION_CHOICE_KEY, pj,
			 XV_KEY_DATA, CHOICE_BUTTON_KEY, ph,
			 NULL);

	window_fit(Pchoice);
	window_fit(Fchoice);
	window_fit_height(panel);
	canvas = (Canvas)xv_create(frame, CANVAS, 
		XV_X, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		CANVAS_REPAINT_PROC,	repaint,
		CANVAS_X_PAINT_WINDOW,	TRUE,
		NULL);
	window_fit(frame);

/* popup */
	m = (Menu)xv_create(NULL, MENU,
		MENU_GEN_PIN_WINDOW, frame, "Popup Menu",
		MENU_ACTION_ITEM, "Quit", exit,
		NULL);
	xv_set(canvas_paint_window(canvas),
		WIN_CONSUME_EVENTS,	WIN_MOUSE_BUTTONS, NULL,
		WIN_EVENT_PROC,		show_it,
		WIN_CLIENT_DATA,	m,
		NULL);
	xv_main_loop(frame);
}

