/* frame.size.c -- Default, minimum, maximum size
 * Author:  Kenneth Bibb
 * April 1992 -- Arastar Consulting
 *-----------------------------------
 * frame with size params
 *	minimum, default, max sizes
 *	also, footer and header
 */

#include <stdlib.h>
#include <sys/param.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/openmenu.h>
#include <xview/icon.h>
#include <xview/svrimage.h>

main(argc, argv)
int argc;
char **argv;
{
	Frame		frame;
	Canvas		canvas;
	Panel		panel;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
	frame = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,	argv[0],
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_HEADER, TRUE,
		XV_WIDTH,	200,
		XV_HEIGHT,	300,
		FRAME_MIN_SIZE,	20, 30,
		FRAME_MAX_SIZE, 400, 600,
		XV_X,		300,
		XV_Y,		175,
		NULL);
	panel = (Panel)xv_create(frame, PANEL, NULL);

	window_fit_height(panel);
	canvas = (Canvas)xv_create(frame, CANVAS, 
		XV_X, 0,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		CANVAS_X_PAINT_WINDOW,	TRUE,
		NULL);
	window_fit(frame);

	xv_main_loop(frame);
}

