/* general.c -- XView general attributes
 * Author:  Kenneth Bibb
 * January 1992 -- Arastar Consulting
 *-----------------------------------
 * Basic frame with panel and canvas
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/font.h>

main(argc, argv)
int argc;
char **argv;
{
	Frame		frame;
	Font		fixed;
	Canvas		canvas;
	Panel		panel;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

	/* get a fixed font */
	fixed = (Font)xv_find(XV_NULL, FONT,
		FONT_NAME,	"fixed",
		NULL);

	/* create the base frame */
	frame = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,		argv[0],
		FRAME_SHOW_FOOTER,	TRUE,
		XV_X,			300,
		XV_Y,			175,
		NULL);

	/* create the panel */
	panel = (Panel)xv_create(frame, PANEL,
			PANEL_LAYOUT,	PANEL_VERTICAL,
			NULL);
	(Panel_item)xv_create(panel, PANEL_CHOICE,
			PANEL_LABEL_STRING,	"Rocks:",
			PANEL_CHOICE_STRINGS,	"Amethyst",
						"Beryl",
						"Chalcedony",
						"Diamond",
						"Emerald",
						NULL,
			/*
			XV_X,		100,
			XV_Y,		100,
			PANEL_LABEL_X,	100,
			PANEL_LABEL_Y,	100,
			PANEL_VALUE_X,	200,
			PANEL_VALUE_Y,	200,
			*/
			NULL);
			
	(void)xv_create(panel, PANEL_BUTTON,
			PANEL_LABEL_FONT,	fixed,
			PANEL_LABEL_STRING,	"Hobo",
			PANEL_NEXT_COL,		50,
			NULL);
	window_fit_height(panel);
	window_fit(frame);

	xv_main_loop(frame);
}

