/* icon.c -- Icon test program
 * Author:  Kenneth Bibb
 * April 1992 -- Arastar Consulting
 *--------------------------------------
 */

#include <stdlib.h>
#include <sys/param.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/openmenu.h>
#include <xview/svrimage.h>
#include <xview/icon.h>
#include <xview/notify.h>

#define ANIME 1

short state0_image[]={
#include "state0.icon"
};

short state1_image[]={
#include "state1.icon"
};

short anime0_image[]={
#include "a0.icon"
};

short anime1_image[]={
#include "a1.icon"
};

short anime2_image[]={
#include "a2.icon"
};

short anime3_image[]={
#include "a3.icon"
};

short anime4_image[]={
#include "a4.icon"
};

short anime5_image[]={
#include "a5.icon"
};

short anime6_image[]={
#include "a6.icon"
};

short anime7_image[]={
#include "a7.icon"
};

short anime8_image[]={
#include "a8.icon"
};

Frame frame;
Frame Fstate;
Frame Fanime;
Icon		state0;
Icon		animate0;
Server_image	s0image;
Server_image	s1image;
Server_image	a0image;
Server_image	a1image;
Server_image	a2image;
Server_image	a3image;
Server_image	a4image;
Server_image	a5image;
Server_image	a6image;
Server_image	a7image;
Server_image	a8image;
int current_state=0;
int animate_state=0;
struct itimerval t;

void menu_stub(m,mi)
Menu m;
Menu_item mi;
{
	printf("Menu: [%s]\n",xv_get(mi,MENU_STRING));
}

void change_state_icon(item,event)
Panel_item	item;
Event		*event;
{
	if(current_state)
	{
		xv_set(state0,ICON_IMAGE,s0image,NULL);
		current_state=0;
	}
	else
	{
		xv_set(state0,ICON_IMAGE,s1image,NULL);
		current_state=1;
	}
}

void animate_state_icon(item,event)
Panel_item	item;
Event		*event;
{
	if(++animate_state < 500)
		xv_set(animate0,ICON_IMAGE,(animate_state%20) ? a0image
			:a8image,NULL);
	else if(animate_state == 500)
		xv_set(animate0,ICON_IMAGE,a1image,NULL);
	else if(animate_state == 501)
		xv_set(animate0,ICON_IMAGE,a2image,NULL);
	else if(animate_state == 502)
		xv_set(animate0,ICON_IMAGE,a3image,NULL);
	else if(animate_state == 503)
		xv_set(animate0,ICON_IMAGE,a4image,NULL);
	else if(animate_state == 504)
		xv_set(animate0,ICON_IMAGE,a5image,NULL);
	else if(animate_state > 504 && animate_state < 600)
		xv_set(animate0,ICON_IMAGE,(animate_state%10) ? a6image
			:a7image,NULL);
	else if(animate_state > 599 && animate_state < 1100)
		xv_set(animate0,ICON_IMAGE, a6image, NULL);
	else
	{
		xv_set(animate0,ICON_IMAGE, a6image, NULL);
		animate_state = 0;
	}
}

void movie(item,value)
Panel_item item;
int value;
{
	if(value)
	{
		t.it_interval.tv_usec = t.it_value.tv_usec =
			(value + 40) * 1000;
		notify_set_itimer_func(frame,animate_state_icon,
			ITIMER_REAL,&t,NULL);
	}
	else
		notify_set_itimer_func(frame,NOTIFY_FUNC_NULL,
			ITIMER_REAL, NULL, NULL);
}

void state(m,mi)
Menu m;
Menu_item mi;
{
	/* when the switch state button on the base frame is pressed,
	 * change the state of the icon
	 */
	xv_set(Fstate,XV_SHOW, TRUE, NULL);
}

void anime(m,mi)
Menu m;
Menu_item mi;
{
	animate_state=0;
	xv_set(animate0,ICON_IMAGE,a0image,NULL);
	xv_set(Fanime,XV_SHOW, TRUE, NULL);
}

main(argc, argv)
int argc;
char **argv;
{
	Canvas		canvas;
	Panel		panel;
	Panel		Pstate;			/* site panel */
#ifdef ANIME
	Panel		Panime;			/* site panel */
#endif
	Menu		m, m_undo;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
	s0image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, state0_image,
		NULL);
	s1image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, state1_image,
		NULL);
	a0image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, anime0_image,
		NULL);
	a1image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, anime1_image,
		NULL);
	a2image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, anime2_image,
		NULL);
	a3image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, anime3_image,
		NULL);
	a4image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, anime4_image,
		NULL);
	a5image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, anime5_image,
		NULL);
	a6image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, anime6_image,
		NULL);
	a7image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, anime7_image,
		NULL);
	a8image = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		XV_WIDTH,	64,
		XV_HEIGHT,	64,
		SERVER_IMAGE_BITS, anime8_image,
		NULL);
	state0 = (Icon)xv_create(XV_NULL,ICON,
			ICON_IMAGE, s0image,
			ICON_LABEL, "icon",
			NULL);
	animate0 = (Icon)xv_create(XV_NULL,ICON,
			ICON_IMAGE, a0image,
			ICON_LABEL, "icon",
			NULL);
	frame = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,	argv[0],
		XV_X,		300,
		XV_Y,		175,
		NULL);
	Fstate = (Frame)xv_create(frame, FRAME,
		FRAME_LABEL,	"State",
		FRAME_ICON,	state0,
		FRAME_CLOSED,	TRUE,
		XV_X,		350,
		XV_Y,		300,
		NULL);
	Fanime = (Frame)xv_create(frame, FRAME,
		FRAME_LABEL,	"Animate",
		FRAME_ICON,	animate0,
		FRAME_CLOSED,	TRUE,
		XV_X,		400,
		XV_Y,		300,
		NULL);
	panel = (Panel)xv_create(frame, PANEL, NULL);
	Pstate= (Panel)xv_create(Fstate, PANEL, NULL);
#ifdef ANIME
	Panime= (Panel)xv_create(Fanime, PANEL, NULL);
#endif

	m = (Menu)xv_create(NULL, MENU,
		MENU_ACTION_ITEM,	"State...", state,
		MENU_ITEM,
			MENU_STRING,	"Animated...",
#ifdef ANIME
			MENU_NOTIFY_PROC,anime,
#else
			MENU_INACTIVE,	TRUE,
#endif
			NULL,
		NULL);
	(void)xv_create(panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"View",
		PANEL_ITEM_MENU,	m,
		NULL);
	
	(void)xv_create(panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Change State",
		PANEL_NOTIFY_PROC,	change_state_icon,
		NULL);
	(void)xv_create(panel,PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Animate",
		PANEL_NOTIFY_PROC,	animate_state_icon,
		NULL);
	(void)xv_create(panel,PANEL_SLIDER,
		PANEL_LABEL_STRING,	"Frame Delay:",
		PANEL_VALUE,		60,
		PANEL_MIN_VALUE,	0,
		PANEL_MAX_VALUE,	100,
		PANEL_NOTIFY_PROC,	movie,
		NULL);

	window_fit(Pstate);
	window_fit(Fstate);
	window_fit_height(panel);
	canvas = (Canvas)xv_create(frame, CANVAS, 
		XV_X, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		CANVAS_X_PAINT_WINDOW,	TRUE,
		NULL);
	window_fit(frame);

	xv_main_loop(frame);
}

