/* shtty.c -- Execute a command from the command line
 * Author:  Kenneth Bibb
 * April 1992 -- Arastar Consulting
 *-----------------------------------
 * Basic frame with panel and ttysw
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/tty.h>
#include <sys/wait.h>

Attr_attribute FRAME_BASE_KEY;

Notify_value wait_func(tty, pid, wait, rusage)
Tty	tty;
int	pid;
union wait	*wait;
struct rusage	*rusage;
{
	if(!WIFSTOPPED(*wait))
	{
		xv_set(xv_get(tty,XV_KEY_DATA,FRAME_BASE_KEY),
			FRAME_LEFT_FOOTER,
			"Your job has completed: Please quit from window menu",
			NULL);
	}
	else
	{
		xv_set(xv_get(tty,XV_KEY_DATA,FRAME_BASE_KEY),
			FRAME_LEFT_FOOTER,
			"Your job has stopped: Please quit from window menu",
			NULL);
	}
	return(NOTIFY_DONE);
}

int main(argc, argv)
int argc;
char **argv;
{
	Frame		frame;
	Tty		tty;
	Panel		panel;
	Panel_item	pc, pl, pi;
	int		i;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
	FRAME_BASE_KEY = xv_unique_key();

	for(i=1; i<argc; i++)
		argv[i-1] = argv[i];
	argv[i-1] = NULL;

	/* create the base frame */
	frame = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,		argv[0],
		FRAME_SHOW_FOOTER,	TRUE,
		XV_X,			300,
		XV_Y,			175,
		NULL);

	/* create the panel */
	panel = (Panel)xv_create(frame, PANEL, NULL);
	window_fit_height(panel);

	/* create the ttysw */
	tty = (Tty)xv_create(frame, TTY, 
		WIN_ROWS,	24,
		WIN_COLUMNS,	80,
		TTY_ARGV,	argv,
		XV_KEY_DATA,	FRAME_BASE_KEY, frame,
		NULL);
	
	/* monitor the child process */
	notify_set_wait3_func(tty, wait_func, (int)xv_get(tty,TTY_PID));

	/* fit the frame around the ttysw and panel */
	window_fit(frame);

	xv_main_loop(frame);
	return(0);
}

