/*
 * aboutwin.c - Notify and event callback function stubs.
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "aboutwin_ui.h"
#include "msgboard.h"
#include "msgboard_xv.h"
#include "about_msg.h"
#include "version.h"

#define ADDR_OTHER	2

aboutwin_frame_objects		*about_ip;
aboutwin_fb_frame_objects	*about_fb_ip;

int
    about_window_created = FALSE;	/* is about window created?	*/
    about_fb_window_created = FALSE;	/* is about mail feedback window
						 created?	*/
void
create_about_fb_window()
{
#ifdef SCALABLE
    int tp_w, ypos;
#endif

    about_fb_ip = aboutwin_fb_frame_objects_initialize(NULL, base_frame);

#ifdef SCALABLE
    xv_set(about_fb_ip->message5, XV_X, wgrid * 2, XV_Y, wgrid * 2, NULL);
    ypos = wgrid * 3 + (int)xv_get(about_fb_ip->message5, XV_HEIGHT);
    xv_set(about_fb_ip->message6, XV_X, wgrid * 2, XV_Y, ypos, NULL);
    ypos += (int)xv_get(about_fb_ip->message6, XV_HEIGHT) + wgrid * 2;
    xv_set(about_fb_ip->addr_item, XV_X, wgrid * 2, XV_Y, ypos, NULL);
    xv_set(about_fb_ip->other_item, XV_X, wgrid * 13, XV_Y, ypos, NULL);
    window_fit(about_fb_ip->fb_top_panel);
    tp_w = (int)xv_get(about_fb_ip->fb_top_panel, XV_WIDTH);
    ypos = (int)xv_get(about_fb_ip->fb_top_panel, XV_HEIGHT);
    xv_set(about_fb_ip->fb_textsw,
	XV_Y,		ypos,
	XV_WIDTH,	tp_w,
	XV_HEIGHT,	(int)(wgrid * 16.8),
	NULL);
    
    xv_set(about_fb_ip->fb_bot_panel,
	XV_Y,		ypos + (int)(wgrid * 16.8),
	XV_WIDTH,	tp_w,
	NULL);
    xv_set(about_fb_ip->fb_send_item, XV_Y, wgrid * 2, NULL);
    xv_set(about_fb_ip->fb_cancel_item, XV_Y, wgrid * 2, NULL);
    window_fit_height(about_fb_ip->fb_bot_panel);
    position_bot_buttons(about_fb_ip->fb_bot_panel, about_fb_ip->fb_send_item,
	about_fb_ip->fb_cancel_item);
    window_fit(about_fb_ip->fb_frame);
#endif

    xv_set(about_fb_ip->other_item, XV_SHOW, FALSE, NULL);
    xv_set(about_fb_ip->fb_textsw,
	TEXTSW_IGNORE_LIMIT,	TEXTSW_INFINITY,
	NULL);

    about_fb_window_created = TRUE;
}

void
show_about_fb_window()
{
    if (!about_fb_window_created) create_about_fb_window();

    textsw_reset(about_fb_ip->fb_textsw, 0, 0);

    xv_set(about_fb_ip->fb_frame, XV_SHOW, TRUE, NULL);
}

void
create_about_window()
{
#ifdef SCALABLE
    int xpos, ypos, tp_h;
#endif
    int options = FALSE;
    char mess1[80];
    Panel_item    glyph;

    about_ip = aboutwin_frame_objects_initialize(NULL, base_frame);

    /*
     *  Manually create the glyph image.  We do this with devGuide
     *  because we want to use the already existing server image of the
     *  msgboard logo.
     */
    glyph = (Panel_item)xv_create(about_ip->ab_top_panel, PANEL_MESSAGE,
	XV_KEY_DATA, INSTANCE, about_ip,
	XV_X, 16,
	XV_Y, 16,
	XV_WIDTH, 64,
	XV_HEIGHT, 64,
	PANEL_LABEL_IMAGE, (Server_image)xv_get(
				(Icon)xv_get(base_frame, FRAME_ICON),
				ICON_IMAGE),
	NULL);

#ifdef SCALABLE
    xpos = wgrid * 3 + (int)xv_get(glyph, XV_WIDTH);
    xv_set(about_ip->message1, XV_X, xpos, XV_Y, wgrid * 2, NULL);
    ypos = wgrid * 3 + (int)xv_get(about_ip->message1, XV_HEIGHT);
    xv_set(about_ip->message2, XV_X, xpos, XV_Y, ypos, NULL);
    ypos += (int)xv_get(about_ip->message2, XV_HEIGHT) + wgrid;
    xv_set(about_ip->message3, XV_X, xpos, XV_Y, ypos, NULL);
    ypos += (int)xv_get(about_ip->message3, XV_HEIGHT) + wgrid;
    xv_set(about_ip->message4, XV_X, xpos, XV_Y, ypos, NULL);
    ypos = (((int)xv_get(about_ip->message1, XV_HEIGHT) * 4 + wgrid * 3) -
	(int)xv_get(glyph, XV_HEIGHT)) / 2 + wgrid * 2;
    xv_set(glyph, XV_X, wgrid * 2, XV_Y, ypos, NULL);
    xv_set(about_ip->ab_top_panel, XV_WIDTH, wgrid * 51, NULL);
    window_fit_height(about_ip->ab_top_panel);

    tp_h = (int)xv_get(about_ip->ab_top_panel, XV_HEIGHT);
    xv_set(about_ip->textsw,
	XV_Y,		tp_h,
	XV_WIDTH,	wgrid * 51,
	XV_HEIGHT,	wgrid * 12,
	NULL);

    xv_set(about_ip->ab_bot_panel,
	XV_Y,		tp_h + wgrid * 12,
	XV_WIDTH,	wgrid * 51,
	NULL);
    xpos = (wgrid * 51 - (int)xv_get(about_ip->send_item, XV_WIDTH)) / 2;
    xv_set(about_ip->send_item,
	XV_X,	xpos,
	XV_Y,	wgrid * 2,
	NULL);
    window_fit_height(about_ip->ab_bot_panel);
    window_fit(about_ip->frame);
    
#endif

    sprintf(mess1, "Message Board %s", PROGRAM_VERSION);

#ifdef SCALABLE
    if (!options)
	strcat(mess1, " (");
    else
	strcat(mess1, ",");
    strcat(mess1, "s");
    options = TRUE;
#endif

    if (options) strcat(mess1, ")");

    xv_set(about_ip->message1, PANEL_LABEL_STRING, mess1, NULL);

    xv_set(about_ip->textsw,
	TEXTSW_IGNORE_LIMIT,	TEXTSW_INFINITY,
	NULL);
    textsw_insert(about_ip->textsw, about_msg, strlen(about_msg));
    textsw_normalize_view(about_ip->textsw, 0);

    about_window_created = TRUE;
}

void
show_about_window()
{
    if (!about_window_created) create_about_window();

    xv_set(about_ip->frame, XV_SHOW, TRUE, NULL);
}

/*
 * Notify callback function for `send_item'.
 */
void
about_send_notify(item, event)
Panel_item	item;
Event		*event;
{	
    show_about_fb_window();
}

/*
 * Notify callback function for `addr_item'.
 */
void
aboutwin_addr_notify(item, value, event)
Panel_item	item;
int		value;
Event		*event;
{	
    if (value == ADDR_OTHER) {
	xv_set(about_fb_ip->other_item, XV_SHOW, TRUE, NULL);
	xv_set(about_fb_ip->fb_top_panel,
	    PANEL_CARET_ITEM, about_fb_ip->other_item,
	    NULL);
	win_set_kbd_focus(about_fb_ip->fb_top_panel,
	    xv_get(about_fb_ip->fb_top_panel, XV_XID));
    }
    else {
	xv_set(about_fb_ip->other_item, XV_SHOW, FALSE, NULL);
	xv_set(item, XV_SHOW, TRUE, NULL); /* Force refresh */
	win_set_kbd_focus(textsw_first(about_fb_ip->fb_textsw),
	    xv_get(textsw_first(about_fb_ip->fb_textsw), XV_XID));
    }
}

/*
 * Notify callback function for `other_item'.
 */
Panel_setting
aboutwin_fb_other_notify(item, event)
Panel_item	item;
Event		*event;
{
    if ( *(char *)xv_get(item, PANEL_VALUE) != '\0')
	win_set_kbd_focus(textsw_first(about_fb_ip->fb_textsw),
	    xv_get(textsw_first(about_fb_ip->fb_textsw), XV_XID));
    return PANEL_NONE;
}

/*
 * Notify callback function for `fb_send_item'.
 */
void
about_fb_send_notify(item, event)
Panel_item	item;
Event		*event;
{
    FILE *pipe;
    char addr[TO_LEN + 1], buf[BUFSIZ+1];
    int addr_sel, last_was_NL;
    Textsw_index cur_pos, next_pos;

    static char *fb_cmd = CNULL;

    if ((int)xv_get(about_fb_ip->fb_textsw, TEXTSW_LENGTH) == 0) {
	pr_msg(NULL, TRUE, "No text in message.");
	xv_set(item, PANEL_NOTIFY_STATUS, XV_ERROR, NULL);
	return;
    }

    addr_sel = (int)xv_get(about_fb_ip->addr_item, PANEL_VALUE);
    if (addr_sel == ADDR_OTHER)
	strncpy(addr, (char *)xv_get(about_fb_ip->other_item, PANEL_VALUE),
	    TO_LEN+1);
    else
	strncpy(addr, (char *)xv_get(about_fb_ip->addr_item,
	    PANEL_CHOICE_STRING, addr_sel), TO_LEN+1);

    if (addr[0] == '\0') {
	pr_msg(NULL, TRUE, "No address specified.");
	xv_set(item, PANEL_NOTIFY_STATUS, XV_ERROR, NULL);
	return;
    }

    if (fb_cmd == CNULL)
	fb_cmd = (char *)malloc(strlen(MAILER) + TO_LEN + 1);

    sprintf(fb_cmd, "%s %s", MAILER, addr);
    if ( (pipe = popen(fb_cmd, "w")) == FNULL) {
	pr_msg(NULL, TRUE, "popen error; couldn't send feedback message!");
	xv_set(item, PANEL_NOTIFY_STATUS, XV_ERROR, NULL);
	return;
    }

    fprintf(pipe, "~s msgboard %s Comment\n\n", PROGRAM_VERSION);

    fprintf(pipe, "\n");
    next_pos = 0;
    cur_pos = next_pos - BUFSIZ;
    while (next_pos == cur_pos + BUFSIZ) {
	cur_pos = next_pos;
	next_pos = (Textsw_index)xv_get(about_fb_ip->fb_textsw,
	    TEXTSW_CONTENTS, cur_pos, buf, BUFSIZ);
	if ((next_pos - cur_pos) != 0) {
	    buf[next_pos - cur_pos] = '\0';
	    fprintf(pipe, "%s", buf);
	    last_was_NL = (buf[next_pos-cur_pos-1] == '\n');
	}
    }
    /*
     *  Force last char out to be a newline
     */
    if (!last_was_NL) putc('\n', pipe);

    if(pclose(pipe) != 0) {
	pr_msg(NULL, TRUE, "Mail failed -- message not sent!");
	xv_set(item, PANEL_NOTIFY_STATUS, XV_ERROR, NULL);
	return;
    }
    textsw_reset(about_fb_ip->fb_textsw, 0, 0);
}

/*
 * Notify callback function for `fb_cancel_item'.
 */
void
about_fb_cancel_notify(item, event)
Panel_item	item;
Event		*event;
{
    textsw_reset(about_fb_ip->fb_textsw, 0, 0);
}
