/*
 *  pmsg_client.c: routines for sending and scanning phone messages
 *  to and from the RPC server.
 */

#include <stdio.h>
#include <string.h
#include "msgboard.h"
#include "mb_client.h"
#include "pmsg_client.h"

int
send_msg_to_server(msg)
struct pmsg *msg;
{
    unsigned int *result;
    int retval;

/*    result = send_pmsg_1(&req, cl); */
/*	retval = *result; */

    if (retval != MSGD_OK) {
	pr_msg(NULL, TRUE, "Could not send phone message; reason: %s.",
	    msgd_err[retval]);
	return FALSE;
    }
    else
	return TRUE;
}

struct pmsg_hdr *
get_pmsg_headers(user, cat, count)
char *user;
int cat, *count;
{
    struct pmsg_hdr *ph_ptr;

    *count = 0;
/*    result = scan_pmsg_1(&req, cl); */

#ifdef FIXITINTHEMIX
    if (result->ret_type != MSGD_OK)
	return (struct pmsg_hdr *)NULL;
    
    for (hl = result->scan_pmsg_data_u.list; hl != NULL; hl = hl->next) {
	if (*count == 0)
	    ph_ptr = (struct pmsg_hdr *)malloc(sizeof(struct pmsg_hdr));
	else
	    ph_ptr = (struct pmsg_hdr *)realloc(ph_ptr,
				sizeof(struct pmsg_hdr) * (*count + 1));
	ph_ptr[*count].desc = strdup(hl->desc);    
	ph_ptr[*count].id = strdup(hl->tag);
	(*count)++;
    }
#endif

    return ph_ptr;
}

/*
 *  Passed: user, cat, id, pointer to pmsg struct
 *  Modifies: pointers to malloc'ed data in msg struct.
 */
int
get_pmsg(user, cat, id, msg)
char *user, *id;
int cat;
struct pmsg *msg;
{
    struct srv_pmsg *rmsg;
    int retval;

/*    result = read_pmsg_1(&req, cl); */

#ifdef FIXITINTHEMIX
    if (result->ret_type != MSGD_OK)
	return result->ret_type;

    rmsg = &(result->read_pmsg_data_u.msg);
    msg->id = strdup(rmsg->id);
    msg->caller = strdup(rmsg->caller);
    msg->time = strdup(rmsg->time);
    msg->org = strdup(rmsg->org);
    msg->phnum = strdup(rmsg->phnum);
    msg->flags = rmsg->flags;
    msg->text = strdup(rmsg->text);
#endif

    retval = MSGD_OK;
    return retval;
}

/*
 *  Frees all the malloc'ed items pointed to in the structure pointed
 *  to by mp.
 */
void
free_pmsg(mp)
struct pmsg *mp;
{
   free(mp->id);
   free(mp->caller);
   free(mp->time);
   free(mp->org);
   free(mp->phnum);
   free(mp->text);
}

/*
 *  Passed: current msg category, destination category, number of messages
 *	to move, list of message headers
 *  Returns: number of messages actually moved
 */
int
mv_msg_call(user, src, dest, num, list)
char *user;
int src, dest, num;
char **list;
{
    int *result, i;

/*    result = mv_pmsgs_1(&req, cl); */

    return *result;
}
